commit 6feb42c8cc2d17d4b1aff4bd482ba7b88b3f872d
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Fri Feb 9 13:48:18 2018 +0100

    Patch 1.0.1:
    
    - Introduced target/Makefile for conventient building and flashing from a single location.
    - Added stm32flash (version 0.5) as Git submodule.
    - Enhancements to the various bash scripts. Most of all, these scripts can now be executed from arbitrary location.

diff --git a/.gitmodules b/.gitmodules
new file mode 100644
index 0000000..6dfff5f
--- /dev/null
+++ b/.gitmodules
@@ -0,0 +1,3 @@
+[submodule "Host/stm32flash"]
+	path = Host/Source/stm32flash
+	url = https://git.code.sf.net/p/stm32flash/code
diff --git a/Host/Source/SerialBoot/main.c b/Host/Source/SerialBoot/main.c
index 0370812..a41964d 100644
--- a/Host/Source/SerialBoot/main.c
+++ b/Host/Source/SerialBoot/main.c
@@ -215,7 +215,7 @@ static void DisplayProgramInfo(void)
   printf("Copyright (c) by Feaser  http://www.feaser.com                             \n");
   printf("---------------------------------------------------------------------------\n");
   printf("This tool was modified for the 'Autonomous Mini Robot' - AMiRo.            \n");
-  printf("Copyright (c) 2016..2017  Marvin Barther, Thomas Schoepping, and Stefan    \n");
+  printf("Copyright (c) 2016..2018  Marvin Barther, Thomas Schoepping, and Stefan    \n");
   printf("                          Herbrechtsmeier                                  \n");
   printf("This is free software; see the source for copying conditions. There is NO  \n");
   printf("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n");
diff --git a/Host/Source/stm32flash b/Host/Source/stm32flash
new file mode 160000
index 0000000..1f934ae
--- /dev/null
+++ b/Host/Source/stm32flash
@@ -0,0 +1 @@
+Subproject commit 1f934ae86babdeea47afdfae1d856d5fd5da6c53
diff --git a/Target/Demo/ARMCM3_STM32F103_DiWheelDrive_GCC/Boot/main.c b/Target/Demo/ARMCM3_STM32F103_DiWheelDrive_GCC/Boot/main.c
index 91ed292..dbe643f 100644
--- a/Target/Demo/ARMCM3_STM32F103_DiWheelDrive_GCC/Boot/main.c
+++ b/Target/Demo/ARMCM3_STM32F103_DiWheelDrive_GCC/Boot/main.c
@@ -170,7 +170,7 @@ void blCallbackHandleShutdownRequest(void);
 
 const blCallbackTable_t cbtable __attribute__ ((section ("_callback_table"))) = {
   .magicNumber = BL_MAGIC_NUMBER,
-  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Release, BL_VERSION_MAJOR, BL_VERSION_MINOR, 0},
+  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Release, BL_VERSION_MAJOR, BL_VERSION_MINOR, 1},
   .vSSSP = {BL_VERSION_ID_SSSP, SSSP_VERSION_MAJOR, SSSP_VERSION_MINOR, 0},
   .vCompiler = {BL_VERSION_ID_GCC, __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__},  // currently only GCC is supported
   .cbShutdownHibernate = blCallbackShutdownHibernate,
diff --git a/Target/Demo/ARMCM3_STM32F103_LightRing_GCC/Boot/main.c b/Target/Demo/ARMCM3_STM32F103_LightRing_GCC/Boot/main.c
index 7189013..02c94bd 100644
--- a/Target/Demo/ARMCM3_STM32F103_LightRing_GCC/Boot/main.c
+++ b/Target/Demo/ARMCM3_STM32F103_LightRing_GCC/Boot/main.c
@@ -140,7 +140,7 @@ void blCallbackHandleShutdownRequest(void);
 
 const blCallbackTable_t cbtable __attribute__ ((section ("_callback_table"))) = {
   .magicNumber = BL_MAGIC_NUMBER,
-  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Release, BL_VERSION_MAJOR, BL_VERSION_MINOR, 0},
+  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Release, BL_VERSION_MAJOR, BL_VERSION_MINOR, 1},
   .vSSSP = {BL_VERSION_ID_SSSP, SSSP_VERSION_MAJOR, SSSP_VERSION_MINOR, 0},
   .vCompiler = {BL_VERSION_ID_GCC, __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__},  // currently only GCC is supported
   .cbShutdownHibernate = blCallbackShutdownHibernate,
diff --git a/Target/Demo/ARMCM4_STM32F405_Power_Management_GCC/Boot/main.c b/Target/Demo/ARMCM4_STM32F405_Power_Management_GCC/Boot/main.c
index af10977..b3f02c3 100644
--- a/Target/Demo/ARMCM4_STM32F405_Power_Management_GCC/Boot/main.c
+++ b/Target/Demo/ARMCM4_STM32F405_Power_Management_GCC/Boot/main.c
@@ -193,7 +193,7 @@ void blCallbackHandleShutdownRequest(void);
 
 const blCallbackTable_t cbtable __attribute__ ((section ("_callback_table"))) = {
   .magicNumber = BL_MAGIC_NUMBER,
-  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Release, BL_VERSION_MAJOR, BL_VERSION_MINOR, 0},
+  .vBootloader = {BL_VERSION_ID_AMiRoBLT_Release, BL_VERSION_MAJOR, BL_VERSION_MINOR, 1},
   .vSSSP = {BL_VERSION_ID_SSSP, SSSP_VERSION_MAJOR, SSSP_VERSION_MINOR, 0},
   .vCompiler = {BL_VERSION_ID_GCC, __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__},  // currently only GCC is supported
   .cbShutdownHibernate = blCallbackShutdownHibernate,
diff --git a/Target/Demo/flash.mk b/Target/Demo/flash.mk
index 06b0141..ea49a09 100644
--- a/Target/Demo/flash.mk
+++ b/Target/Demo/flash.mk
@@ -1,4 +1,4 @@
-STM32FLASH = stm32flash
+STM32FLASH := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))../../Host/Source/stm32flash/stm32flash
 ifeq ($(OS),Windows_NT)
 	STM32FLASH_PORT ?= COM5
 else
diff --git a/Target/Makefile b/Target/Makefile
new file mode 100644
index 0000000..084801f
--- /dev/null
+++ b/Target/Makefile
@@ -0,0 +1,59 @@
+################################################################################
+# AMiRo-BLT is the bootloader and flashing toolchain for the base version of   #
+# the Autonomous Mini Robot (AMiRo). It is based on OpenBLT developed by       #
+# Feaser (see <http://feaser.com/en/openblt.php>).                             #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
+#                                                                              #
+# This program is free software: you can redistribute it and/or modify         #
+# it under the terms of the GNU General Public License as published by         #
+# the Free Software Foundation, either version 3 of the License, or            #
+# (at your option) any later version.                                          #
+#                                                                              #
+# This program is distributed in the hope that it will be useful,              #
+# but WITHOUT ANY WARRANTY; without even the implied warranty of               #
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 #
+# GNU General Public License for more details.                                 #
+#                                                                              #
+# You should have received a copy of the GNU General Public License            #
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.        #
+#                                                                              #
+# This research/work was supported by the Cluster of Excellence Cognitive      #
+# Interaction Technology 'CITEC' (EXC 277) at Bielefeld University, which is   #
+# funded by the German Research Foundation (DFG).                              #
+################################################################################
+
+
+
+ROOT_PATH = ..
+DWD_PATH = $(ROOT_PATH)/Target/Demo/ARMCM3_STM32F103_DiWheelDrive_GCC/Boot
+PM_PATH = $(ROOT_PATH)/Target/Demo/ARMCM4_STM32F405_Power_Management_GCC/Boot
+LR_PATH = $(ROOT_PATH)/Target/Demo/ARMCM3_STM32F103_LightRing_GCC/Boot
+
+all:
+	$(MAKE) -C $(DWD_PATH)
+	$(MAKE) -C $(PM_PATH)
+	$(MAKE) -C $(LR_PATH)
+
+clean:
+	$(MAKE) -C $(DWD_PATH) clean
+	$(MAKE) -C $(PM_PATH) clean
+	$(MAKE) -C $(LR_PATH) clean
+
+DiWheelDrive:
+	$(MAKE) -C $(DWD_PATH)
+
+PowerManagement:
+	$(MAKE) -C $(PM_PATH)
+
+LightRing:
+	$(MAKE) -C $(LR_PATH)
+
+flash_DiWheelDrive:
+	$(MAKE) -C $(DWD_PATH) flash
+
+flash_PowerManagement:
+	$(MAKE) -C $(PM_PATH) flash
+
+flash_LightRing:
+	$(MAKE) -C $(LR_PATH) flash
+
